package com.ibm.xml.dom;

import java.util.Vector;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class DeepNodeListImpl implements NodeList {
   protected NodeImpl rootNode;
   protected String tagName;
   protected int changes;
   protected Vector nodes;

   public DeepNodeListImpl(NodeImpl var1, String var2) {
      this.rootNode = var1;
      this.tagName = var2;
      this.nodes = new Vector();
   }

   public int getLength() {
      this.item(Integer.MAX_VALUE);
      return this.nodes.size();
   }

   public Node item(int var1) {
      if (this.rootNode.changes != this.changes) {
         this.nodes = new Vector();
         this.changes = this.rootNode.changes;
      }

      if (var1 < this.nodes.size()) {
         return (Node)this.nodes.elementAt(var1);
      } else {
         Object var2;
         if (this.nodes.size() == 0) {
            var2 = this.rootNode;
         } else {
            var2 = (NodeImpl)this.nodes.lastElement();
         }

         while(var2 != null && var1 >= this.nodes.size()) {
            var2 = this.nextMatchingElementAfter((Node)var2);
            if (var2 != null) {
               this.nodes.addElement(var2);
            }
         }

         return (Node)var2;
      }
   }

   private Node nextMatchingElementAfter(Node var1) {
      while(var1 != null) {
         if (var1.hasChildNodes()) {
            var1 = var1.getFirstChild();
         } else {
            Node var2;
            if (var1 != this.rootNode && (var2 = var1.getNextSibling()) != null) {
               var1 = var2;
            } else {
               for(var2 = null; var1 != this.rootNode; var1 = var1.getParentNode()) {
                  var2 = var1.getNextSibling();
                  if (var2 != null) {
                     break;
                  }
               }

               var1 = var2;
            }
         }

         if (var1 != this.rootNode && var1 != null && var1.getNodeType() == 1 && (this.tagName.equals("*") || ((ElementImpl)var1).getTagName().equals(this.tagName))) {
            return var1;
         }
      }

      return null;
   }
}
