package com.ibm.xml.dom;

public final class DeferredAttrImpl extends AttrImpl implements DeferredNode {
   static final long serialVersionUID = 8793967374959140933L;
   protected transient int fNodeIndex;

   DeferredAttrImpl(DeferredDocumentImpl var1, int var2) {
      super(var1, (String)null);
      this.fNodeIndex = var2;
      super.syncData = true;
      super.syncChildren = true;
   }

   public int getNodeIndex() {
      return this.fNodeIndex;
   }

   protected void synchronizeData() {
      super.syncData = false;
      DeferredDocumentImpl var1 = (DeferredDocumentImpl)super.ownerDocument;
      super.name = var1.getNodeNameString(this.fNodeIndex);
      super.specified = var1.getNodeValue(this.fNodeIndex) == 1;
   }

   protected void synchronizeChildren() {
      super.syncChildren = false;
      DeferredDocumentImpl var1 = (DeferredDocumentImpl)super.ownerDocument;
      NodeImpl var2 = null;

      for(int var3 = var1.getFirstChild(this.fNodeIndex); var3 != -1; var3 = var1.getNextSibling(var3)) {
         NodeImpl var4 = (NodeImpl)var1.getNodeObject(var3);
         if (var2 == null) {
            super.firstChild = var4;
         } else {
            var2.nextSibling = var4;
         }

         var4.parentNode = this;
         var4.previousSibling = var2;
         var2 = var4;
      }

      if (var2 != null) {
         super.lastChild = var2;
      }

   }
}
