package com.ibm.xml.dom;

import org.w3c.dom.NamedNodeMap;

public class DeferredDocumentTypeImpl extends DocumentTypeImpl implements DeferredNode {
   static final long serialVersionUID = -2172579663227313509L;
   protected transient int fNodeIndex;

   DeferredDocumentTypeImpl(DeferredDocumentImpl var1, int var2) {
      super(var1, (String)null);
      this.fNodeIndex = var2;
      super.syncData = true;
      super.syncChildren = true;
   }

   public int getNodeIndex() {
      return this.fNodeIndex;
   }

   protected void synchronizeData() {
      super.syncData = false;
      DeferredDocumentImpl var1 = (DeferredDocumentImpl)super.ownerDocument;
      super.name = var1.getNodeNameString(this.fNodeIndex);
   }

   protected void synchronizeChildren() {
      super.syncChildren = false;
      DeferredDocumentImpl var1 = (DeferredDocumentImpl)super.ownerDocument;
      super.entities = new NamedNodeMapImpl(var1, (NamedNodeMapImpl)null);
      super.notations = new NamedNodeMapImpl(var1, (NamedNodeMapImpl)null);
      super.elements = new NamedNodeMapImpl(var1, (NamedNodeMapImpl)null);

      for(int var2 = var1.getFirstChild(this.fNodeIndex); var2 != -1; var2 = var1.getNextSibling(var2)) {
         DeferredNode var3 = var1.getNodeObject(var2);
         short var4 = var3.getNodeType();
         switch (var4) {
            case -1:
               super.elements.setNamedItem(var3);
               NamedNodeMap var5 = var3.getAttributes();

               for(int var6 = var1.getFirstChild(var3.getNodeIndex()); var6 != -1; var6 = var1.getNextSibling(var6)) {
                  DeferredNode var7 = var1.getNodeObject(var6);
                  var5.setNamedItem(var7);
               }
               break;
            case 6:
               super.entities.setNamedItem(var3);
               break;
            case 12:
               super.notations.setNamedItem(var3);
               break;
            default:
               System.out.println("DeferredDocumentTypeImpl#synchronizeInfo: node.getNodeType() = " + var3.getNodeType() + ", class = " + var3.getClass().getName());
         }
      }

   }
}
