package com.ibm.xml.dom;

public class DeferredElementDefinitionImpl extends ElementDefinitionImpl implements DeferredNode {
   static final long serialVersionUID = 6703238199538041591L;
   protected transient int fNodeIndex;

   DeferredElementDefinitionImpl(DeferredDocumentImpl var1, int var2) {
      super(var1, (String)null);
      this.fNodeIndex = var2;
      super.syncData = true;
      super.syncChildren = true;
   }

   public int getNodeIndex() {
      return this.fNodeIndex;
   }

   protected void synchronizeData() {
      super.syncData = false;
      DeferredDocumentImpl var1 = (DeferredDocumentImpl)super.ownerDocument;
      super.name = var1.getNodeNameString(this.fNodeIndex);
   }

   protected void synchronizeChildren() {
      super.syncChildren = false;
      DeferredDocumentImpl var1 = (DeferredDocumentImpl)super.ownerDocument;
      super.attributes = new NamedNodeMapImpl(var1, (NamedNodeMapImpl)null);

      for(int var2 = var1.getFirstChild(this.fNodeIndex); var2 != -1; var2 = var1.getNextSibling(var2)) {
         DeferredNode var3 = var1.getNodeObject(var2);
         super.attributes.setNamedItem(var3);
      }

   }
}
