package com.ibm.xml.dom;

import org.w3c.dom.NamedNodeMap;

public class DeferredElementImpl extends ElementImpl implements DeferredNode {
   static final long serialVersionUID = 1698024469924430384L;
   protected transient int fNodeIndex;

   DeferredElementImpl(DeferredDocumentImpl var1, int var2) {
      super(var1, (String)null);
      this.fNodeIndex = var2;
      super.syncData = true;
      super.syncChildren = true;
   }

   public final int getNodeIndex() {
      return this.fNodeIndex;
   }

   protected final void synchronizeData() {
      super.syncData = false;
      DeferredDocumentImpl var1 = (DeferredDocumentImpl)super.ownerDocument;
      super.name = var1.getNodeNameString(this.fNodeIndex);
      ((ElementImpl)this).setupDefaultAttributes();
      int var2 = var1.getNodeValue(this.fNodeIndex);
      if (var2 != -1) {
         NamedNodeMap var3 = ((ElementImpl)this).getAttributes();

         do {
            NodeImpl var4 = (NodeImpl)var1.getNodeObject(var2);
            var3.setNamedItem(var4);
            var4.parentNode = this;
            var2 = var1.getNextSibling(var2);
         } while(var2 != -1);
      }

   }

   protected final void synchronizeChildren() {
      super.syncChildren = false;
      DeferredDocumentImpl var1 = (DeferredDocumentImpl)super.ownerDocument;
      NodeImpl var2 = null;

      for(int var3 = var1.getFirstChild(this.fNodeIndex); var3 != -1; var3 = var1.getNextSibling(var3)) {
         NodeImpl var4 = (NodeImpl)var1.getNodeObject(var3);
         if (var2 == null) {
            super.firstChild = var4;
         } else {
            var2.nextSibling = var4;
         }

         var4.parentNode = this;
         var4.previousSibling = var2;
         var2 = var4;
      }

      if (var2 != null) {
         super.lastChild = var2;
      }

   }
}
