package com.ibm.xml.dom;

import com.ibm.xml.framework.StringPool;

public class DeferredEntityImpl extends EntityImpl implements DeferredNode {
   static final long serialVersionUID = 4760180431078941638L;
   protected transient int fNodeIndex;

   DeferredEntityImpl(DeferredDocumentImpl var1, int var2) {
      super(var1, (String)null);
      this.fNodeIndex = var2;
      super.syncData = true;
      super.syncChildren = true;
   }

   public int getNodeIndex() {
      return this.fNodeIndex;
   }

   protected void synchronizeData() {
      super.syncData = false;
      DeferredDocumentImpl var1 = (DeferredDocumentImpl)super.ownerDocument;
      super.name = var1.getNodeNameString(this.fNodeIndex);
      StringPool var2 = var1.fParserState.getStringPool();
      int var3 = var1.getNodeValue(this.fNodeIndex);
      super.publicId = var2.toString(var1.getFirstChild(var3));
      super.systemId = var2.toString(var1.getLastChild(var3));
      super.notationName = var2.toString(var1.getPreviousSibling(var3));
   }

   protected void synchronizeChildren() {
      super.syncChildren = false;
      DeferredDocumentImpl var1 = (DeferredDocumentImpl)super.ownerDocument;

      for(int var2 = var1.getFirstChild(this.fNodeIndex); var2 != -1; var2 = var1.getNextSibling(var2)) {
         DeferredNode var3 = var1.getNodeObject(var2);
         ((NodeImpl)this).appendChild(var3);
      }

   }
}
