package com.ibm.xml.dom;

import org.w3c.dom.DocumentType;
import org.w3c.dom.Entity;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

public class DeferredEntityReferenceImpl extends EntityReferenceImpl implements DeferredNode {
   static final long serialVersionUID = 390319091370032223L;
   protected transient int fNodeIndex;

   DeferredEntityReferenceImpl(DeferredDocumentImpl var1, int var2) {
      super(var1, (String)null);
      this.fNodeIndex = var2;
      super.syncData = true;
      super.syncChildren = true;
   }

   public int getNodeIndex() {
      return this.fNodeIndex;
   }

   protected void synchronizeData() {
      super.syncData = false;
      DeferredDocumentImpl var1 = (DeferredDocumentImpl)super.ownerDocument;
      super.name = var1.getNodeNameString(this.fNodeIndex);
   }

   protected void synchronizeChildren() {
      super.syncChildren = false;
      DocumentType var1 = super.ownerDocument.getDoctype();
      boolean var2 = false;
      if (var1 != null) {
         NamedNodeMap var3 = var1.getEntities();
         if (var3 != null) {
            Entity var4 = (Entity)var3.getNamedItem(((NodeImpl)this).getNodeName());
            if (var4 != null) {
               var2 = true;
               super.readOnly = false;

               for(Node var5 = var4.getFirstChild(); var5 != null; var5 = var5.getNextSibling()) {
                  ((NodeImpl)this).appendChild(var5.cloneNode(true));
               }

               super.readOnly = true;
            }
         }
      }

      if (!var2) {
         DeferredDocumentImpl var6 = (DeferredDocumentImpl)super.ownerDocument;
         int var7 = var6.getFirstChild(this.fNodeIndex);

         for(super.readOnly = false; var7 != -1; var7 = var6.getNextSibling(var7)) {
            DeferredNode var8 = var6.getNodeObject(var7);
            ((NodeImpl)this).appendChild(var8);
         }

         super.readOnly = true;
      }

   }
}
