package com.ibm.xml.dom;

import org.w3c.dom.DOMException;
import org.w3c.dom.DocumentType;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

public class DocumentTypeImpl extends NodeImpl implements DocumentType {
   static final long serialVersionUID = 7751299192316526485L;
   protected NamedNodeMapImpl entities;
   protected NamedNodeMapImpl notations;
   protected NamedNodeMapImpl elements;

   public DocumentTypeImpl(DocumentImpl var1, String var2) {
      super(var1, var2, (String)null);
      this.entities = new NamedNodeMapImpl(var1, (NamedNodeMapImpl)null);
      this.notations = new NamedNodeMapImpl(var1, (NamedNodeMapImpl)null);
      this.elements = new NamedNodeMapImpl(var1, (NamedNodeMapImpl)null);
   }

   public short getNodeType() {
      return 10;
   }

   public void setNodeValue(String var1) throws DOMException {
      throw new DOMExceptionImpl((short)7, (String)null);
   }

   public Node cloneNode(boolean var1) {
      DocumentTypeImpl var2 = (DocumentTypeImpl)super.cloneNode(var1);
      var2.entities = this.entities.cloneMap();
      var2.notations = this.notations.cloneMap();
      var2.elements = this.elements.cloneMap();
      return var2;
   }

   public String getName() {
      if (super.syncData) {
         ((NodeImpl)this).synchronizeData();
      }

      return super.name;
   }

   public NamedNodeMap getEntities() {
      if (super.syncChildren) {
         ((NodeImpl)this).synchronizeChildren();
      }

      return this.entities;
   }

   public NamedNodeMap getNotations() {
      if (super.syncChildren) {
         ((NodeImpl)this).synchronizeChildren();
      }

      return this.notations;
   }

   public void setReadOnly(boolean var1, boolean var2) {
      if (super.syncChildren) {
         ((NodeImpl)this).synchronizeChildren();
      }

      this.setReadOnly(var1, var2);
      this.elements.setReadOnly(var1, true);
      this.entities.setReadOnly(var1, true);
      this.notations.setReadOnly(var1, true);
   }

   public NamedNodeMap getElements() {
      if (super.syncChildren) {
         ((NodeImpl)this).synchronizeChildren();
      }

      return this.elements;
   }
}
