package com.ibm.xml.dom;

import org.w3c.dom.Node;
import org.w3c.dom.ProcessingInstruction;

public class ProcessingInstructionImpl extends NodeImpl implements ProcessingInstruction {
   static final long serialVersionUID = 7554435174099981510L;

   public ProcessingInstructionImpl(DocumentImpl var1, String var2, String var3) {
      super(var1, var2, var3);
   }

   public short getNodeType() {
      return 7;
   }

   public Node cloneNode(boolean var1) {
      return super.ownerDocument.createProcessingInstruction(super.name, super.value);
   }

   public String getTarget() {
      if (super.syncData) {
         ((NodeImpl)this).synchronizeData();
      }

      return super.name;
   }

   public String getData() {
      if (super.syncData) {
         ((NodeImpl)this).synchronizeData();
      }

      return super.value;
   }

   public void setData(String var1) {
      if (super.readOnly) {
         throw new DOMExceptionImpl((short)7, (String)null);
      } else {
         if (super.syncData) {
            ((NodeImpl)this).synchronizeData();
         }

         super.value = var1;
      }
   }
}
