package com.ibm.xml.dom;

import org.w3c.dom.DOMException;
import org.w3c.dom.Node;
import org.w3c.dom.Text;

public class TextImpl extends CharacterDataImpl implements Text {
   static final long serialVersionUID = -5294980852957403469L;
   protected boolean ignorableWhitespace;

   public TextImpl(DocumentImpl var1, String var2) {
      super(var1, var2);
   }

   public short getNodeType() {
      return 3;
   }

   public String getNodeName() {
      return "#text";
   }

   public Node cloneNode(boolean var1) {
      return super.ownerDocument.createTextNode(((NodeImpl)this).getNodeValue());
   }

   public void setIgnorableWhitespace(boolean var1) {
      if (super.syncData) {
         ((NodeImpl)this).synchronizeData();
      }

      this.ignorableWhitespace = var1;
   }

   public boolean isIgnorableWhitespace() {
      if (super.syncData) {
         ((NodeImpl)this).synchronizeData();
      }

      return this.ignorableWhitespace;
   }

   public Text splitText(int var1) throws DOMException {
      if (super.readOnly) {
         throw new DOMExceptionImpl((short)7, (String)null);
      } else {
         if (super.syncData) {
            ((NodeImpl)this).synchronizeData();
         }

         if (var1 >= 0 && var1 <= super.value.length() - 1) {
            Text var2 = super.ownerDocument.createTextNode(super.value.substring(var1));
            ((NodeImpl)this).setNodeValue(super.value.substring(0, var1));
            if (super.parentNode != null) {
               super.parentNode.insertBefore(var2, super.nextSibling);
            }

            return var2;
         } else {
            throw new DOMExceptionImpl((short)1, (String)null);
         }
      }
   }
}
